<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">


<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    
    <title>2. 作成したプログラム &mdash; 計算機実習 1.0 documentation</title>
    
    <link rel="stylesheet" href="../_static/default.css" type="text/css" />
    <link rel="stylesheet" href="../_static/pygments.css" type="text/css" />
    
    <script type="text/javascript">
      var DOCUMENTATION_OPTIONS = {
        URL_ROOT:    '../',
        VERSION:     '1.0',
        COLLAPSE_INDEX: false,
        FILE_SUFFIX: '.html',
        HAS_SOURCE:  true
      };
    </script>
    <script type="text/javascript" src="../_static/jquery.js"></script>
    <script type="text/javascript" src="../_static/underscore.js"></script>
    <script type="text/javascript" src="../_static/doctools.js"></script>
    <link rel="top" title="計算機実習 1.0 documentation" href="../index.html" />
    <link rel="up" title="計算機実習 問題6.2 ロジスティック写像の定性的な特徴" href="6-2.html" />
    <link rel="next" title="3. 実習課題" href="experiment.html" />
    <link rel="prev" title="1. シミュレーションの目的" href="purpose.html" /> 
  </head>
  <body>
    <div class="related">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="experiment.html" title="3. 実習課題"
             accesskey="N">next</a> |</li>
        <li class="right" >
          <a href="purpose.html" title="1. シミュレーションの目的"
             accesskey="P">previous</a> |</li>
        <li><a href="../index.html">計算機実習 1.0 documentation</a> &raquo;</li>
          <li><a href="6-2.html" accesskey="U">計算機実習 問題6.2 ロジスティック写像の定性的な特徴</a> &raquo;</li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body">
            
  <div class="section" id="id1">
<h1>2. 作成したプログラム<a class="headerlink" href="#id1" title="Permalink to this headline">¶</a></h1>
<p>Pythonを用いて作成したプログラムを以下に示す。</p>
<div class="highlight-python"><table class="highlighttable"><tr><td class="linenos"><div class="linenodiv"><pre> 1
 2
 3
 4
 5
 6
 7
 8
 9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30</pre></div></td><td class="code"><div class="highlight"><pre><span class="c">#!/usr/bin/env python </span>
<span class="c"># coding:utf-8</span>
<span class="c">#</span>
<span class="c"># written by Shotaro Fujimoto, May 2014.</span>
<span class="sd">&quot;&quot;&quot; 計算機実習</span>
<span class="sd">問題6.8</span>
<span class="sd">プログラムを実行すると、パラメータの設定ダイアログが開き、</span>
<span class="sd">OKボタンを押すとグラフが描画される。</span>
<span class="sd">いろいろなrについてxの値をプロットする。</span>
<span class="sd">&quot;&quot;&quot;</span>
<span class="kn">from</span> <span class="nn">math</span> <span class="kn">import</span> <span class="o">*</span>
<span class="kn">import</span> <span class="nn">SetParameter</span>
<span class="kn">import</span> <span class="nn">myplot_bifurcation</span>

<span class="k">def</span> <span class="nf">assignment</span><span class="p">():</span>
    <span class="n">x0</span> <span class="o">=</span> <span class="nb">float</span><span class="p">(</span><span class="n">run</span><span class="o">.</span><span class="n">entry</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span><span class="o">.</span><span class="n">get</span><span class="p">())</span>
    <span class="n">ntransient</span> <span class="o">=</span> <span class="nb">int</span><span class="p">(</span><span class="n">run</span><span class="o">.</span><span class="n">entry</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span><span class="o">.</span><span class="n">get</span><span class="p">())</span>
    <span class="n">nplot</span> <span class="o">=</span> <span class="nb">int</span><span class="p">(</span><span class="n">run</span><span class="o">.</span><span class="n">entry</span><span class="p">[</span><span class="mi">2</span><span class="p">]</span><span class="o">.</span><span class="n">get</span><span class="p">())</span>
    <span class="n">r0</span> <span class="o">=</span> <span class="nb">float</span><span class="p">(</span><span class="n">run</span><span class="o">.</span><span class="n">entry</span><span class="p">[</span><span class="mi">3</span><span class="p">]</span><span class="o">.</span><span class="n">get</span><span class="p">())</span>
    <span class="n">rmax</span> <span class="o">=</span> <span class="mf">1.0</span>
    <span class="n">dr</span> <span class="o">=</span> <span class="nb">float</span><span class="p">(</span><span class="n">run</span><span class="o">.</span><span class="n">entry</span><span class="p">[</span><span class="mi">4</span><span class="p">]</span><span class="o">.</span><span class="n">get</span><span class="p">())</span>
    <span class="k">def</span> <span class="nf">func</span><span class="p">(</span><span class="n">x_i</span><span class="p">,</span> <span class="n">r</span><span class="p">):</span>
        <span class="k">return</span> <span class="mf">4.0</span><span class="o">*</span><span class="n">r</span><span class="o">*</span><span class="n">x_i</span><span class="o">*</span><span class="p">(</span><span class="mf">1.0</span><span class="o">-</span><span class="n">x_i</span><span class="p">)</span>
    <span class="n">run</span><span class="o">.</span><span class="n">quit</span><span class="p">()</span>
    <span class="n">myplot_bifurcation</span><span class="o">.</span><span class="n">Plot</span><span class="p">(</span><span class="n">func</span><span class="p">,</span> <span class="n">x0</span><span class="p">,</span> <span class="n">ntransient</span><span class="p">,</span> <span class="n">nplot</span><span class="p">,</span> <span class="n">r0</span><span class="p">,</span> <span class="n">rmax</span><span class="p">,</span> <span class="n">dr</span><span class="p">)</span>
    
<span class="k">if</span> <span class="n">__name__</span> <span class="o">==</span> <span class="s">&#39;__main__&#39;</span><span class="p">:</span>
    <span class="n">run</span> <span class="o">=</span> <span class="n">SetParameter</span><span class="o">.</span><span class="n">SetParameter</span><span class="p">()</span>
    <span class="n">parameters</span> <span class="o">=</span> <span class="p">[{</span><span class="s">&#39;x0&#39;</span><span class="p">:</span><span class="mf">0.3</span><span class="p">},</span> <span class="p">{</span><span class="s">&#39;ntransient&#39;</span><span class="p">:</span><span class="mi">1000</span><span class="p">},</span> <span class="p">{</span><span class="s">&#39;nplot&#39;</span><span class="p">:</span><span class="mi">50</span><span class="p">},</span> <span class="p">{</span><span class="s">&#39;r0&#39;</span><span class="p">:</span><span class="mf">0.7</span><span class="p">},</span> <span class="p">{</span><span class="s">&#39;dr&#39;</span><span class="p">:</span><span class="mf">0.0005</span><span class="p">}]</span>
    <span class="n">run</span><span class="o">.</span><span class="n">show_setting_window</span><span class="p">(</span><span class="n">parameters</span><span class="p">,</span> <span class="p">{</span><span class="s">&#39;OK&#39;</span><span class="p">:</span><span class="n">assignment</span><span class="p">})</span>
</pre></div>
</td></tr></table></div>
<p>このプログラムは、追加のモジュールとして、matplotlibを使用している。プログラムを実行すると各パラメータ{x0, ntransient, nplot, r0, dr}(x0:xの初期値 <img class="math" src="../_images/math/7583bd67b9c0a3880e53a7bd15ce980540c3e5cb.png" alt="x_{0}"/> , ntransient:プロットしないnの範囲, nplot:プロットするnの大きさ, r0:制御パラメータ <img class="math" src="../_images/math/2ede365ad144ab396916ec60458da03860803078.png" alt="r"/> の初期値, dr:プロットする <img class="math" src="../_images/math/2ede365ad144ab396916ec60458da03860803078.png" alt="r"/> の刻み幅)の設定ダイアログが開き、値を設定してOKボタンを押すことで、その値で計算されたロジスティック写像の分岐図が描画される。はじめのntransient回は、計算はするがプロットはされず、次のnplot回は赤でプロットし、その後のnplot回は青でプロットする。</p>
</div>


          </div>
        </div>
      </div>
      <div class="sphinxsidebar">
        <div class="sphinxsidebarwrapper">
  <h4>Previous topic</h4>
  <p class="topless"><a href="purpose.html"
                        title="previous chapter">1. シミュレーションの目的</a></p>
  <h4>Next topic</h4>
  <p class="topless"><a href="experiment.html"
                        title="next chapter">3. 実習課題</a></p>
  <h3>This Page</h3>
  <ul class="this-page-menu">
    <li><a href="../_sources/6-2_bifurcate/program.txt"
           rel="nofollow">Show Source</a></li>
  </ul>
<div id="searchbox" style="display: none">
  <h3>Quick search</h3>
    <form class="search" action="../search.html" method="get">
      <input type="text" name="q" />
      <input type="submit" value="Go" />
      <input type="hidden" name="check_keywords" value="yes" />
      <input type="hidden" name="area" value="default" />
    </form>
    <p class="searchtip" style="font-size: 90%">
    Enter search terms or a module, class or function name.
    </p>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="experiment.html" title="3. 実習課題"
             >next</a> |</li>
        <li class="right" >
          <a href="purpose.html" title="1. シミュレーションの目的"
             >previous</a> |</li>
        <li><a href="../index.html">計算機実習 1.0 documentation</a> &raquo;</li>
          <li><a href="6-2.html" >計算機実習 問題6.2 ロジスティック写像の定性的な特徴</a> &raquo;</li> 
      </ul>
    </div>
    <div class="footer">
        &copy; Copyright 2014, Shotaro Fujimoto.
      Created using <a href="http://sphinx-doc.org/">Sphinx</a> 1.2.2.
    </div>
  </body>
</html>